﻿//-----------------------------------------------
//TUSB-0224ADM用ドライバアクセス用API
//Visual C# 用モジュール
//
//2017_05_19　株式会社タートル工業
//Copyright (C) 2017 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

using TU_STATUS = System.UInt32;

class TUSB0224ADM
{
    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Connect(string SerialNumber);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_DisConnect(string SerialNumber);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Calib_Val(string SerialNumber, byte Ch, [Out] int[] Offset, [Out] double[] Lsbv);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Dio_In(string SerialNumber, out byte InData);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Dio_Out(string SerialNumber, byte OutData);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_SyncMode(string SerialNumber, byte Mode);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_SyncAdj(string SerialNumber, byte Com);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Ad_Sample(string SerialNumber, [Out] int[] Data);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Ad_IntClock(string SerialNumber, byte Sel, uint ClkDiv, byte Filter);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Ad_Input(string SerialNumber, byte Ch, byte Sens, byte Couple, byte Gain);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Ad_InputChk(string SerialNumber, byte Ch, out byte Sens, out byte Couple, out byte Gain);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_TrgLevel(string SerialNumber, byte Select, byte AinSel, int Level1, int Level2);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_Start(string SerialNumber, uint PreTrgLen, byte SampleChSel);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_Stop(string SerialNumber);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_Status(string SerialNumber, byte Ch, out byte Status, out uint DataLen);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_Data(string SerialNumber, byte Ch, [Out] int[] Data, ref uint DataLen);

    [DllImport("TUSB0224ADM.DLL", CallingConvention = CallingConvention.StdCall)]
    public static extern TU_STATUS TUSB0224ADM_Smpl_SoftTrigger(string SerialNumber);

    public static string GetErrMessage(TU_STATUS retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "引数が不正です";
            case 2:
                return "接続されていません";
            case 3:
                return "接続されている台数が多すぎます";
            case 4:
                return "デバイスがみつかりません";
            case 5:
                return "デバイスは接続されていません";
            case 6:
                return "USB通信エラーです";
            case 7:
                return "デバイスは接続されています";
            case 8:
                return "サンプリング動作中です";
            default:
                return "不明なエラーです";
        }
    }
}

