﻿'-----------------------------------------------
'TUSB-0224ADM用ドライバアクセス用API
'Visual Basic 用モジュール
'
'2017_11_28　株式会社タートル工業
'Copyright (C) 2017 Turtle Industry Co.,Ltd.
'-----------------------------------------------

Imports System.Runtime.InteropServices

Imports TU_STATUS = System.UInt32

Module TUSB0224ADM
    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Connect(
                                ByVal SerialNumber As String
                                ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_DisConnect(
                                   ByVal SerialNumber As String
                                   ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Calib_Val(
                                   ByVal SerialNumber As String,
                                   ByVal Ch As Byte,
                                   <Out()> ByVal Offset() As Integer,
                                   <Out()> ByVal Lsbv() As Double
                                   ) _
                                   As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Dio_In(
                               ByVal SerialNumber As String,
                               <Out> ByRef InData As Byte
                               ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Dio_Out(
                                ByVal SerialNumber As String,
                                ByVal InData As Byte
                                ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_SyncMode(
                                 ByVal SerialNumber As String,
                                 ByVal Mode As Byte
                                 ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_SyncAdj(
                                ByVal SerialNumber As String,
                                ByVal Com As Byte
                                ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Ad_Sample(
                                  ByVal SerialNumber As String,
                                  <Out()> ByVal Data() As Integer
                                  ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Ad_IntClock(
                                    ByVal SerialNumber As String,
                                    ByVal Sel As Byte,
                                    ByVal ClkDiv As UInteger,
                                    ByVal Filter As Byte
                                    ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Ad_Input(
                                 ByVal SerialNumber As String,
                                 ByVal Ch As Byte,
                                 ByVal Sens As Byte,
                                 ByVal Couple As Byte,
                                 ByVal Gain As Byte
                                 ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Ad_InputChk(
                                    ByVal SerialNumber As String,
                                    ByVal Ch As Byte,
                                    <Out> ByRef Sens As Byte,
                                    <Out> ByRef Couple As Byte,
                                    <Out> ByRef Gain As Byte
                                    ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_TrgLevel(
                                      ByVal SerialNumber As String,
                                      ByVal _Select As Byte,
                                      ByVal AinSel As Byte,
                                      ByVal Level1 As Integer,
                                      ByVal Level2 As Integer
                                      ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_Start(
                                   ByVal SerialNumber As String,
                                   ByVal PreTrgLen As UInteger,
                                   ByVal SampleChSel As Byte
                                   ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_Stop(
                                  ByVal SerialNumber As String
                                  ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_Status(
                                    ByVal SerialNumber As String,
                                    ByVal Ch As Byte,
                                    <Out> ByRef Status As Byte,
                                    <Out> ByRef DataLen As UInteger
                                    ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_Data(
                                  ByVal SerialNumber As String,
                                  ByVal Ch As Byte,
                                  <Out()> ByVal Data() As Integer,
                                  <[In], Out> ByRef DataLen As UInteger
                                  ) As TU_STATUS
    End Function

    <DllImport("TUSB0224ADM.DLL", CallingConvention:=CallingConvention.StdCall)>
    Function TUSB0224ADM_Smpl_SoftTrigger(
                                         ByVal SerialNumber As String
                                         ) As TU_STATUS
    End Function

    ' Error Message
    Public Function GetErrMessage(ByVal ErrCode As TU_STATUS) As String

        Select Case ErrCode
            Case 0
                Return "正常終了しました"
            Case 1
                Return "引数が不正です"
            Case 2
                Return "接続されていません"
            Case 3
                Return "接続されている台数が多すぎます"
            Case 4
                Return "デバイスがみつかりません"
            Case 5
                Return "デバイスは接続されていません"
            Case 6
                Return "USB通信エラーです"
            Case 7
                Return "デバイスは接続されています"
            Case 8
                Return "サンプリング動作中です"
            Case Else
                Return "不明なエラーです"
        End Select
    End Function
End Module
