﻿Imports System.IO

Public Class Form1
    Private PreInputInitialize As Boolean = True '入力表示初期化前(これがtrueだと入力設定を変化させてもコマンドを送らない)
    Private FileCh(1) As StreamWriter '保存ファイルストリーム
    Private DataCnt(1) As Integer '連続サンプリング取得データ数
    Private CalibOffset(1, 1, 1, 2) As Integer 'オフセット校正数値
    Private CalibLsbv(1, 1, 2) As Double 'スパン校正数値

    'コントロールの表示状態の設定
    Private Sub ControlEn(ByVal st As Integer)
        Select Case st
            Case 0   'デバイス非接続状態の時(プログラム起動直後)
                ConnectBtn.Enabled = True
                DisConnectBtn.Enabled = False
                ADCPanel.Enabled = False
                SerialNumTxt.Enabled = True
            Case 1   ' デバイス接続状態　サンプリング中ではない
                ConnectBtn.Enabled = False
                DisConnectBtn.Enabled = True
                ADCPanel.Enabled = True
                SerialNumTxt.Enabled = False
                ' サンプリングしていない時のみ有効のグループ
                SyncModeGr.Enabled = True
                ClockSyncGr.Enabled = True
                AdClockGr.Enabled = True
                AdInputGr1.Enabled = True
                AdInputGr2.Enabled = True
                TriggerGr.Enabled = True
                'サンプリングコントロールボタン
                SmplStartBtn.Enabled = True
                SmplStopBtn.Enabled = False
                'デバイス接続制御
                DisConnectBtn.Enabled = True
                'トリガボタン
                SoftTriggerBtn.Enabled = False
            Case 2   ' デバイス接続状態　サンプリング中
                ConnectBtn.Enabled = False
                DisConnectBtn.Enabled = True
                ADCPanel.Enabled = True
                SerialNumTxt.Enabled = False
                ' サンプリングして中は無効のグループ
                SyncModeGr.Enabled = False
                ClockSyncGr.Enabled = False
                AdClockGr.Enabled = False
                AdInputGr1.Enabled = False
                AdInputGr2.Enabled = False
                TriggerGr.Enabled = False
                'サンプリングコントロールボタン
                SmplStartBtn.Enabled = False
                SmplStopBtn.Enabled = True
                'デバイス接続制御
                DisConnectBtn.Enabled = False
                If TriggerTypeSel.SelectedIndex = 6 Then
                    SoftTriggerBtn.Enabled = True
                Else
                    SoftTriggerBtn.Enabled = False
                End If
        End Select
    End Sub

    ' Adの入力設定を確認して設定表示を変更する
    Private Sub InputCheck()
        Dim ret As UInteger
        Dim Sens As Byte
        Dim couple As Byte
        Dim Gain As Byte

        PreInputInitialize = True

        ' Ad ch1　のチェック
        ret = TUSB0224ADM.TUSB0224ADM_Ad_InputChk(SerialNumTxt.Text, 0, Sens, couple, Gain)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        Else
            If Sens = 0 Then
                Ch1Att1.Checked = True
            Else
                Ch1Att10.Checked = True
            End If
            If couple = 0 Then
                Ch1DC.Checked = True
            Else
                Ch1AC.Checked = True
            End If
            If Gain = 0 Then
                Ch1Gain0.Checked = True
            ElseIf Gain = 1 Then
                Ch1Gain1.Checked = True
            Else
                Ch1Gain2.Checked = True
            End If
        End If

        ' Ad ch2 のチェック
        ret = TUSB0224ADM.TUSB0224ADM_Ad_InputChk(SerialNumTxt.Text, 1, Sens, couple, Gain)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        Else
            If Sens = 0 Then
                Ch2Att1.Checked = True
            Else
                Ch2Att10.Checked = True
            End If

            If couple = 0 Then
                Ch2DC.Checked = True
            Else
                Ch2AC.Checked = True
            End If

            If Gain = 0 Then
                Ch2Gain0.Checked = True
            ElseIf Gain = 1 Then
                Ch2Gain1.Checked = True
            Else
                Ch2Gain2.Checked = True
            End If
        End If

        PreInputInitialize = False
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' コンボボックスの初期化
        SyncModeSel.SelectedIndex = 0
        AdBaseRateSel.SelectedIndex = 0
        TriggerTypeSel.SelectedIndex = 0

        ControlEn(0) ' コントロール表示状態の初期化
    End Sub


    Private Sub Get_Calib_Val()
        Dim tmpL(8) As Integer
        Dim tmpD(5) As Double

        For ch = 0 To 1
            TUSB0224ADM.TUSB0224ADM_Calib_Val(SerialNumTxt.Text, ch, tmpL, tmpD)
            CalibOffset(ch, 0, 0, 0) = tmpL(0)
            CalibOffset(ch, 0, 0, 1) = tmpL(1)
            CalibOffset(ch, 0, 0, 2) = tmpL(2)
            CalibOffset(ch, 0, 1, 0) = tmpL(3)
            CalibOffset(ch, 0, 1, 1) = tmpL(4)
            CalibOffset(ch, 0, 1, 2) = tmpL(5)
            CalibOffset(ch, 1, 0, 0) = tmpL(6)
            CalibOffset(ch, 1, 0, 1) = tmpL(7)
            CalibOffset(ch, 1, 0, 2) = tmpL(8)
            CalibOffset(ch, 1, 1, 0) = tmpL(6)
            CalibOffset(ch, 1, 1, 1) = tmpL(7)
            CalibOffset(ch, 1, 1, 2) = tmpL(8)
            CalibLsbv(ch, 0, 0) = tmpD(0)
            CalibLsbv(ch, 0, 1) = tmpD(1)
            CalibLsbv(ch, 0, 2) = tmpD(2)
            CalibLsbv(ch, 1, 0) = tmpD(3)
            CalibLsbv(ch, 1, 1) = tmpD(4)
            CalibLsbv(ch, 1, 2) = tmpD(5)
        Next
        CalibDisp1.Text =
                "Offset[0] " & CalibOffset(0, 0, 0, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[1] " & CalibOffset(0, 0, 0, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[2] " & CalibOffset(0, 0, 0, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[3] " & CalibOffset(0, 0, 1, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[4] " & CalibOffset(0, 0, 1, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[5] " & CalibOffset(0, 0, 1, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[6] " & CalibOffset(0, 1, 0, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[7] " & CalibOffset(0, 1, 0, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[8] " & CalibOffset(0, 1, 0, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Lsbv  [0] " & CalibLsbv(0, 0, 0).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [1] " & CalibLsbv(0, 0, 1).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [2] " & CalibLsbv(0, 0, 2).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [3] " & CalibLsbv(0, 1, 0).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [4] " & CalibLsbv(0, 1, 1).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [5] " & CalibLsbv(0, 1, 2).ToString("0.00000000E0") & "[V/LSB]"
        CalibDisp2.Text =
                "Offset[0] " & CalibOffset(1, 0, 0, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[1] " & CalibOffset(1, 0, 0, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[2] " & CalibOffset(1, 0, 0, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[3] " & CalibOffset(1, 0, 1, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[4] " & CalibOffset(1, 0, 1, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[5] " & CalibOffset(1, 0, 1, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[6] " & CalibOffset(1, 1, 0, 0).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[7] " & CalibOffset(1, 1, 0, 1).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Offset[8] " & CalibOffset(1, 1, 0, 2).ToString("+000000;-000000; 000000") & "[LSB]" & vbCrLf &
                "Lsbv  [0] " & CalibLsbv(1, 0, 0).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [1] " & CalibLsbv(1, 0, 1).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [2] " & CalibLsbv(1, 0, 2).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [3] " & CalibLsbv(1, 1, 0).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [4] " & CalibLsbv(1, 1, 1).ToString("0.00000000E0") & "[V/LSB]" & vbCrLf &
                "Lsbv  [5] " & CalibLsbv(1, 1, 2).ToString("0.00000000E0") & "[V/LSB]"
    End Sub

    Private Sub ConnectBtn_Click(sender As Object, e As EventArgs) Handles ConnectBtn.Click
        Dim ret As UInteger
        Try
            ret = TUSB0224ADM.TUSB0224ADM_Connect(SerialNumTxt.Text)
            If ret <> 0 Then
                MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
            Else
                Get_Calib_Val()
                InputCheck()
                ControlEn(1)
                MonitorTimer.Enabled = True
            End If
        Catch ex As Exception ' DLLが見つからない時
            MessageBox.Show(ex.Message, "ErrorMessage")
            MessageBox.Show("ドライバが見つかりません。ドライバが正しくインストールされているか確認してください。", "接続時エラー")
        End Try
    End Sub

    Private Sub DisConnectBtn_Click(sender As Object, e As EventArgs) Handles DisConnectBtn.Click
        Dim ret As UInteger
        MonitorTimer.Enabled = False
        ret = TUSB0224ADM.TUSB0224ADM_DisConnect(SerialNumTxt.Text)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
        ControlEn(0)
    End Sub

    Private Sub SyncModeSetBtn_Click(sender As Object, e As EventArgs) Handles SyncModeSetBtn.Click
        Dim ret As UInteger
        ret = TUSB0224ADM.TUSB0224ADM_SyncMode(SerialNumTxt.Text, CByte(SyncModeSel.SelectedIndex))
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
    End Sub

    Private Sub SyncNormalSel_CheckedChanged(sender As Object, e As EventArgs) Handles SyncNormalSel.CheckedChanged
        Dim ret As UInteger
        ret = TUSB0224ADM.TUSB0224ADM_SyncAdj(SerialNumTxt.Text, 0)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
        SyncADClkBtn.Enabled = True
    End Sub

    Private Sub SyncWaitSel_CheckedChanged(sender As Object, e As EventArgs) Handles SyncWaitSel.CheckedChanged
        Dim ret As UInteger
        ret = TUSB0224ADM.TUSB0224ADM_SyncAdj(SerialNumTxt.Text, 1)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
        SyncADClkBtn.Enabled = False
    End Sub

    Private Sub SyncADClkBtn_Click(sender As Object, e As EventArgs) Handles SyncADClkBtn.Click
        Dim ret As UInteger
        ret = TUSB0224ADM.TUSB0224ADM_SyncAdj(SerialNumTxt.Text, 2)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
    End Sub

    Private Sub CalcSPS(sender As Object, e As EventArgs) Handles AdBaseRateSel.SelectedIndexChanged, FilterSel2.CheckedChanged, FilterSel1.CheckedChanged, DivRate.ValueChanged
        Dim clksps As Double = 0.0
        Dim div As Double

        Select Case AdBaseRateSel.SelectedIndex
            Case 0
                clksps = 512000
            Case 1
                clksps = 256000
            Case 2
                clksps = 128000
            Case 3
                clksps = 64000
            Case 4
                clksps = 400000
            Case 5
                clksps = 200000
            Case 6
                clksps = 100000
            Case 7
                clksps = 50000
            Case 8
                clksps = 11291676.0 / 32.0
            Case 9
                clksps = 11291676.0 / 64.0
            Case 10
                clksps = 11291676.0 / 128.0
            Case 11
                clksps = 11291676.0 / 256.0
            Case 12
                clksps = 384000
            Case 13
                clksps = 192000
            Case 14
                clksps = 96000
            Case 15
                clksps = 48000
            Case 16
                SpsDisp.Text = "外部クロック/" + (32 * (DivRate.Value + 1)).ToString()
                Return
            Case 17
                SpsDisp.Text = "外部クロック/" + (64 * (DivRate.Value + 1)).ToString()
                Return
            Case 18
                SpsDisp.Text = "外部クロック/" + (128 * (DivRate.Value + 1)).ToString()
                Return
            Case 19
                SpsDisp.Text = "外部クロック/" + (256 * (DivRate.Value + 1)).ToString()
                Return
        End Select

        div = CDbl(DivRate.Value)

        clksps /= (div + 1.0) 'データレートを計算する

        If clksps >= 100000.0 Then ' 100kSPS台
            SpsDisp.Text = (clksps / 1000.0).ToString("0.000") + "kSPS"
        ElseIf (clksps >= 10000.0) Then ' 10kSPS台
            SpsDisp.Text = (clksps / 1000.0).ToString("0.000") + "kSPS"
        ElseIf (clksps >= 1000.0) Then ' 1kSPS台
            SpsDisp.Text = (clksps / 1000.0).ToString("0.0000") + "kSPS"
        Else '1kSPS未満
            SpsDisp.Text = clksps.ToString("0.000") + "SPS"
        End If
    End Sub

    Private Sub AdClkSetBtn_Click(sender As Object, e As EventArgs) Handles AdClkSetBtn.Click
        Dim ret As UInteger
        Dim Sel As Byte
        Dim ClkDiv As UInteger
        Dim Filter As Byte

        Sel = CByte(AdBaseRateSel.SelectedIndex)

        ClkDiv = CUInt(DivRate.Value)

        Filter = CByte(IIf(FilterSel1.Checked, 0, 1))

        ret = TUSB0224ADM.TUSB0224ADM_Ad_IntClock(SerialNumTxt.Text, Sel, ClkDiv, Filter)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
    End Sub

    Private Sub Ch1InputChange(sender As Object, e As EventArgs) Handles Ch1Att1.CheckedChanged, Ch1Gain2.CheckedChanged, Ch1Gain1.CheckedChanged, Ch1Gain0.CheckedChanged, Ch1DC.CheckedChanged, Ch1Att10.CheckedChanged, Ch1AC.CheckedChanged
        Dim ret As UInteger
        Dim Sens As Byte
        Dim Couple As Byte
        Dim Gain As Byte

        If PreInputInitialize Then
            Return
        End If

        If sender.GetType().Name = "RadioButton" Then
            If DirectCast(sender, RadioButton).Checked Then
                Sens = IIf(Ch1Att1.Checked, CByte(0), CByte(1))
                Couple = IIf(Ch1DC.Checked, CByte(0), CByte(1))
                Gain = IIf(Ch1Gain0.Checked, CByte(0), IIf(Ch1Gain1.Checked, CByte(1), CByte(2)))

                ret = TUSB0224ADM.TUSB0224ADM_Ad_Input(SerialNumTxt.Text, 0, Sens, Couple, Gain)
                If ret <> 0 Then
                    MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
                End If
            End If
        End If
    End Sub

    Private Sub Ch2InputChange(sender As Object, e As EventArgs) Handles Ch2Att1.CheckedChanged, Ch2Gain2.CheckedChanged, Ch2Gain1.CheckedChanged, Ch2Gain0.CheckedChanged, Ch2DC.CheckedChanged, Ch2Att10.CheckedChanged, Ch2AC.CheckedChanged
        Dim ret As UInteger
        Dim Sens As Byte
        Dim Couple As Byte
        Dim Gain As Byte

        If PreInputInitialize Then
            Return
        End If

        If sender.GetType().Name = "RadioButton" Then
            If DirectCast(sender, RadioButton).Checked Then
                Sens = IIf(Ch2Att1.Checked, CByte(0), CByte(1))
                Couple = IIf(Ch2DC.Checked, CByte(0), CByte(1))
                Gain = IIf(Ch2Gain0.Checked, CByte(0), IIf(Ch2Gain1.Checked, CByte(1), CByte(2)))

                ret = TUSB0224ADM.TUSB0224ADM_Ad_Input(SerialNumTxt.Text, 1, Sens, Couple, Gain)
                If ret <> 0 Then
                    MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
                End If
            End If
        End If
    End Sub

    Private Sub TriggerTypeSel_SelectedIndexChanged(sender As Object, e As EventArgs) Handles TriggerTypeSel.SelectedIndexChanged
        Select Case TriggerTypeSel.SelectedIndex
            Case 0, 1    'アナログ立ち上がり or アナログ立下り
                TrgCh1.Enabled = True
                TrgCh2.Enabled = True
                TrgLevel.Enabled = True
                HysLevel.Enabled = True
                TrgWndUpper.Enabled = False
                TrgWndUnder.Enabled = False
            Case 2, 3    '範囲内 or 範囲外
                TrgCh1.Enabled = True
                TrgCh2.Enabled = True
                TrgLevel.Enabled = False
                HysLevel.Enabled = False
                TrgWndUpper.Enabled = True
                TrgWndUnder.Enabled = True
            Case 4, 5    'デジタル立上り or デジタル立下り
                TrgCh1.Enabled = False
                TrgCh2.Enabled = False
                TrgLevel.Enabled = False
                HysLevel.Enabled = False
                TrgWndUpper.Enabled = False
                TrgWndUnder.Enabled = False
            Case 6    'ソフトウェア
                TrgCh1.Enabled = False
                TrgCh2.Enabled = False
                TrgLevel.Enabled = False
                HysLevel.Enabled = False
                TrgWndUpper.Enabled = False
                TrgWndUnder.Enabled = False
        End Select
    End Sub

    Private Sub TrgSetBtn_Click(sender As Object, e As EventArgs) Handles TrgSetBtn.Click
        Dim ret As UInteger
        Dim trSelect As Byte
        Dim AinSel As Byte
        Dim Level1 As Integer
        Dim Level2 As Integer

        trSelect = CByte(TriggerTypeSel.SelectedIndex)
        AinSel = IIf(TrgCh1.Checked, CByte(0), CByte(1))
        Select Case trSelect
            Case 0, 1
                Level1 = CInt(TrgLevel.Value)
                Level2 = CInt(HysLevel.Value)
            Case 2, 3
                Level1 = CInt(TrgWndUpper.Value)
                Level2 = CInt(TrgWndUnder.Value)
            Case Else
                Level1 = 0
                Level2 = 0
        End Select
        ret = TUSB0224ADM.TUSB0224ADM_Smpl_TrgLevel(SerialNumTxt.Text, trSelect, AinSel, Level1, Level2)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
    End Sub

    Private Sub SmplStartBtn_Click(sender As Object, e As EventArgs) Handles SmplStartBtn.Click
        Dim ret As UInteger
        Dim PreTrgLen As UInteger

        PreTrgLen = CUInt(PreTrg.Value)

        ret = TUSB0224ADM.TUSB0224ADM_Smpl_Start(SerialNumTxt.Text, PreTrgLen, 0)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If

        Dim ftimestr As String = DateTime.Now.ToString("yyyyMMdd_HHmmss")
        FileCh(0) = New StreamWriter(ftimestr + "_Ch1.dat")
        FileCh(1) = New StreamWriter(ftimestr + "_Ch2.dat")
        DataCnt(0) = 0
        DataCnt(1) = 0
        ControlEn(2)
        SmplTimer.Enabled = True
    End Sub

    Private Sub SmplStopBtn_Click(sender As Object, e As EventArgs) Handles SmplStopBtn.Click
        Dim ret As UInteger

        SmplTimer.Enabled = False
        ret = TUSB0224ADM.TUSB0224ADM_Smpl_Stop(SerialNumTxt.Text)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If

        FileCh(0).Close()
        FileCh(1).Close()
        ControlEn(1)
    End Sub

    Private Sub SoftTriggerBtn_Click(sender As Object, e As EventArgs) Handles SoftTriggerBtn.Click
        Dim ret As UInteger

        ret = TUSB0224ADM.TUSB0224ADM_Smpl_SoftTrigger(SerialNumTxt.Text)
        If ret <> 0 Then
            MessageBox.Show(TUSB0224ADM.GetErrMessage(ret))
        End If
    End Sub

    Private Sub DOutSetBtn_Click(sender As Object, e As EventArgs) Handles DOutSetBtn.Click
        Dim ret As UInteger
        Dim OutData As Byte

        OutData = IIf(DOut0Chk.Checked, CByte(1), CByte(0))
        OutData += IIf(DOut1Chk.Checked, CByte(2), CByte(0))
        OutData += IIf(DOut2Chk.Checked, CByte(4), CByte(0))
        OutData += IIf(DOut3Chk.Checked, CByte(8), CByte(0))

        ret = TUSB0224ADM.TUSB0224ADM_Dio_Out(SerialNumTxt.Text, OutData)
        If ret <> 0 Then
            ErrorStatus.Text = TUSB0224ADM.GetErrMessage(ret)
        End If
    End Sub

    Private Sub DInReadBtn_Click(sender As Object, e As EventArgs) Handles DInReadBtn.Click
        Dim ret As UInteger
        Dim InData As Byte

        ret = TUSB0224ADM.TUSB0224ADM_Dio_In(SerialNumTxt.Text, InData)
        If ret <> 0 Then
            ErrorStatus.Text = TUSB0224ADM.GetErrMessage(ret)
        Else
            DIn0Chk.Checked = IIf((InData And &H1) = &H1, True, False)
            DIn1Chk.Checked = IIf((InData And &H2) = &H2, True, False)
            DIn2Chk.Checked = IIf((InData And &H4) = &H4, True, False)
            DIn3Chk.Checked = IIf((InData And &H8) = &H8, True, False)
        End If
    End Sub

    Private Sub SmplTimer_Tick(sender As Object, e As EventArgs) Handles SmplTimer.Tick
        Dim ret As UInteger
        Dim STATTXT() As String = New String() {
                                    "停止中",
                                    "プレトリガ長待機",
                                    "トリガ待ち",
                                    "サンプリング中",
                                    "データオーバフロー"}

        For ch = 0 To 1

            Dim Status As Byte
            Dim DataLen As UInteger

            ret = TUSB0224ADM.TUSB0224ADM_Smpl_Status(SerialNumTxt.Text, ch, Status, DataLen)
            If ret <> 0 Then
                ErrorStatus.Text = TUSB0224ADM.GetErrMessage(ret)
            End If
            If (DataLen > 0) Then
                Dim Data(DataLen - 1) As Integer
                ret = TUSB0224ADM.TUSB0224ADM_Smpl_Data(SerialNumTxt.Text, ch, Data, DataLen)
                If ret <> 0 Then
                    ErrorStatus.Text = TUSB0224ADM.GetErrMessage(ret)
                Else
                    For cnt = 0 To (DataLen - 1)
                        FileCh(ch).WriteLine(Data(cnt))
                    Next
                    DataCnt(ch) += CInt(DataLen)
                End If
            End If

            If ch = 0 Then
                SmplStatus1.Text = STATTXT(Status) + " Data長 = " + DataCnt(ch).ToString()
            Else
                SmplStatus2.Text = STATTXT(Status) + " Data長 = " + DataCnt(ch).ToString()
            End If
        Next
    End Sub

    Private Function GetCOffset(ByVal ch As Integer) As Integer
        If ch = 0 Then ' ch1
            Dim gain As Integer = IIf(Ch1Gain0.Checked, 0, IIf(Ch1Gain1.Checked, 1, 2))
            Dim sens As Integer = IIf(Ch1Att1.Checked, 0, 1)
            Dim couple As Integer = IIf(Ch1DC.Checked, 0, 1)
            Return CalibOffset(0, couple, sens, gain)
        Else 'ch2
            Dim gain As Integer = IIf(Ch2Gain0.Checked, 0, IIf(Ch2Gain1.Checked, 1, 2))
            Dim sens As Integer = IIf(Ch2Att1.Checked, 0, 1)
            Dim couple As Integer = IIf(Ch2DC.Checked, 0, 1)
            Return CalibOffset(1, couple, sens, gain)
        End If
    End Function

    Private Function GetLsbv(ByVal ch As Integer) As Double
        If ch = 0 Then ' ch1 Then
            Dim gain As Integer = IIf(Ch1Gain0.Checked, 0, IIf(Ch1Gain1.Checked, 1, 2))
            Dim sens As Integer = IIf(Ch1Att1.Checked, 0, 1)
            Return CalibLsbv(0, sens, gain)
        Else 'ch2
            Dim gain As Integer = IIf(Ch2Gain0.Checked, 0, IIf(Ch2Gain1.Checked, 1, 2))
            Dim sens As Integer = IIf(Ch2Att1.Checked, 0, 1)
            Return CalibLsbv(1, sens, gain)
        End If
    End Function
    Private Sub MonitorTimer_Tick(sender As Object, e As EventArgs) Handles MonitorTimer.Tick
        Dim ret As UInteger
        Dim Data(1) As Integer

        ret = TUSB0224ADM.TUSB0224ADM_Ad_Sample(SerialNumTxt.Text, Data)
        If ret = 0 Then
            Dim lsbv(1) As Double
            For ch = 0 To 1
                lsbv(ch) = CDbl(Data(ch) - GetCOffset(ch)) * GetLsbv(ch)
            Next
            VInTxt1.Text = lsbv(0).ToString("+00.000000;-00.000000; 00.000000")
            VInTxt2.Text = lsbv(1).ToString("+00.000000;-00.000000; 00.000000")
        End If

    End Sub
End Class
